// main function
// add grocery list as musical scores

// initialize mouse manager
Mouse mouse;
spork ~ mouse.start(0);  // start listening for mouse events
spork ~ mouse.selfUpdate(); // start updating mouse position

global string s1, s2, tt; 
// simulated calculator

15 => int numNum; // 10 numbers, =, +, C, and chuck

Event buttonReleaseEvent;

////// Setup constants

global int currInput;
int lastInput;

0 => int MODE; // 0 for nothing, 1 for plus, -1 for minus
0 => int LAST_MODE;
10 => int EQUAL;
11 => int PLUS;
12 => int MINUS;
13 => int CLEAR;
14 => int CHUCK;

"" => string register;
"" => string prevRegister;
5 => int maxReg; // maximum register to be displayed

0 => int prevNum;
0 => int currNum;
0 => int result;

// receipt index
0 => int rcptIdx;

[
    @(0, 2, 0),
    @(0, 1, 0),
    @(0, 0, 0),
    @(0, -1, 0)
] @=> vec3 rcptPositions[];

// button positions
0.6 => float gs; // grid size
[
    @(-2, -4, 0) * gs,
    @(-2, -2, 0) * gs,
    @( 0, -2, 0) * gs,
    @( 2, -2, 0) * gs,
    @(-2,  0, 0) * gs,
    @( 0,  0, 0) * gs,
    @( 2,  0, 0) * gs,
    @(-2,  2, 0) * gs,
    @( 0,  2, 0) * gs,
    @( 2,  2, 0) * gs,
    @( 1, -4, 0) * gs,
    @( 4,  2, 0) * gs, // 11 +
    @( 4,  0, 0) * gs, // 12 - 
    @( 4,  -2, 0) * gs, // 13 C
    @( 4,  -4, 0) * gs, // chuck
] @=> vec3 positions[];

vec3 sizes[numNum];
for(int i; i < 10; i++)
{
    @(1, 1, 0) => sizes[i];
}

gs * 2 - 1 => float gap;

@(gap + 2, 1, 0) => sizes[10];
// @(1, gap + 2, 0) => sizes[11];
@(1, 1, 0) => sizes[11];
@(1, 1, 0) => sizes[12];
@(1, 1, 0) => sizes[13];
@(1, 1, 0) => sizes[14];

[
    59, 60, 62, 64, 65, 67, 69, 71, 72, 74, 76, 79, 84, 86, 0
] @=> global int pitches[];
// global string s1, s2;

[
     @(0.79, 0.83, 0.80) * 0.9,    // NONE
    @(0.79, 0.83, 0.80),   // HOVERED
    @(237, 233, 216)/255, // ACTIVE
    Color.GREEN     // PLAYING
] @=> vec3 numberPalette[];

[
    @(0.90, 0.75, 0.09) * 0.9,    // NONE
    @(0.90, 0.75, 0.09),      // HOVERED
    @(0.90, 0.75, 0.09),  // ACTIVE
    Color.GREEN     // PLAYING
] @=> vec3 functionPalette[];

@(0.137, 0.322, 0.364) => vec3 backplateColor;
@(0.28, 0.8, 0.6) * 1.2 => vec3 displayColor;


////// GGen Initiation //////

GGen calcAnchor;
GGen rcptAnchor;

calcAnchor.posX(-3.5);
rcptAnchor.posX(3.5);

calcAnchor --> GG.scene();
rcptAnchor --> GG.scene();


// buttons
GButton buttons[numNum];
Printing prints[numNum];


for(int i; i < numNum; i++)
{
    prints[i].init(i, buttons[i]);

    buttons[i].pos(positions[i]);
    buttons[i] --> calcAnchor;

    if( i > 9)
    {
        buttons[i].init(mouse, prints[i], pitches[i], sizes[i], functionPalette, i, buttonReleaseEvent);
    }
    else
    {
        buttons[i].init(mouse, prints[i], pitches[i], sizes[i], numberPalette, i, buttonReleaseEvent);
    }
}


// backplate and display
GPlane backplate --> calcAnchor;
FlatMaterial m1;
backplate.mat(m1);
backplate.mat().color( backplateColor );
backplate.sca( @( 8 * gs, 10 * gs, 0 ) * 1.1 ) ;
backplate.pos( @( 1 * gs, 0 * gs, -1 ) );

Display display --> calcAnchor;
MusicBox musicbox;
musicbox.setSpeed(70);
display.pos( @( gs, 4 * gs + 0.1, 0 ) );


// receipt
FlatMaterial m2;
GPlane paper --> rcptAnchor;
paper.mat(m2);
paper.mat().color(  @(237, 233, 216)/255 );
paper.sca( @( 8 * gs, 10 * gs, 0 ) * 1.1 ) ;
paper.pos( @( 0, 0, 0 ) );

GText title --> rcptAnchor;
title.text("Draft Paper");
title.pos( @( -1.3, 2.8, 1 ) );
title.color( @(0, 0, 0) );
title.sca( 0.3 );


Receipt rcpt[4];
// rcpt.init(mouse, cm1);
// rcpt --> rcptAnchor;
// rcpt.pos(@(0, 2, 0));


6 => int numSubtitle;
0 => int currSubtitle;
GText subtitles[numSubtitle];

for( int i; i < numSubtitle; i++ )
{
    subtitles[i].pos( @(0, -4, 1));
    subtitles[i].color( @(1, 1, 1) * 0.9 );
    subtitles[i].sca( 0.4 );
    // subtitles[i] --> GG.scene();
}

subtitles[0].text("This is a calculator.");
subtitles[1].text("It can make sound and perform simple calculation.");
subtitles[2].text("Boring monophonic, right?");
subtitles[3].text("So we need to write the score down.");
subtitles[4].text("Let's try some homophonic music.");
subtitles[5].text("Thank you!");


////// Scene Setting //////

GG.scene().backgroundColor( @(0.79, 0.83, 0.80) * 0.3 );
// GG.scene().backgroundColor( @(0.45, 0.41, 0.36) );
// GG.fullscreen();
GG.font(me.dir() + "./fonts/SpaceMono-Regular.ttf");

GG.camera().orthographic();
GG.camera().viewSize(10);
// GG.camera().pos(@(0, 0, 20));
GG.resolution(1920, 1080);

// GG.fx() --> BloomFX bloom --> OutputFX output;
// 0.8 => output.gamma;
// 1 => output.exposure;

// global int currInput;
fun void buttonListener()
{
    while (true)
    {
        buttonReleaseEvent => now;
        <<<"Button Pressed: ", currInput>>>;
    }
}
spork ~ buttonListener();


fun string toString(int input)
{
    return "" + input;
}


fun void inputMonitor()
{
    while ( true )
    {
        buttonReleaseEvent => now;

        if( currInput < 10 )
        {
            if( lastInput == EQUAL )
            {
                "" => register;
            }
            if( register.length() < maxReg )
            {
                toString(currInput) +=> register;
            }
            else
            {
                register.substring(1) + toString(currInput)  => register;
            }
        }
        else
        {
            // equal
            if( currInput == CLEAR )
            {
                "" => register;
                // if( lastInput == CLEAR )
                // {
                //     spork ~ musicbox.stopPlay();
                // }
            }
            else if( currInput == CHUCK )
            {
                spork ~ musicbox.stopPlay();
            }
            else if( currInput == EQUAL )
            {
                // in plus mode
                if( MODE == 1 ) 
                {

                    register.toInt() => currNum;
                    prevNum + currNum => result;

                    // set socre before register and prvRegister are overridden
                    rcpt[rcptIdx].init(mouse, musicbox, prevRegister, MODE, register, toString(result));
                    // <<<"here">>>;
                    rcpt[rcptIdx] --> rcptAnchor;
                    rcpt[rcptIdx].pos(rcptPositions[rcptIdx]);
                    (rcptIdx + 1) % 4 => rcptIdx;


                    toString(result) => register;
                    register => prevRegister;

                    // result => prevNum;
                    // <<<"Result: ", result>>>;
                    // <<<"Register: " + register>>>;
                }
                // in minus mode
                else if( MODE == -1 )
                {
                    register.toInt() => currNum;
                    prevNum - currNum => result;

                    // set socre before register and prvRegister are overridden
                    rcpt[rcptIdx].init(mouse, musicbox, prevRegister, MODE, register, toString(result));
                    rcpt[rcptIdx] --> rcptAnchor;
                    rcpt[rcptIdx].pos(rcptPositions[rcptIdx]);
                    (rcptIdx + 1) % 4 => rcptIdx;

                    toString(result) => register;
                    register => prevRegister;
                }
                
                0 => MODE;
            }
            // plus
            else if( currInput == PLUS )
            {
                <<<register>>>;
                register.toInt() => prevNum;
                1 => MODE;

                register => prevRegister;
                "" => register;
                // <<<"Prev: ", prevNum>>>;
            }
            // minus
            else if ( currInput == MINUS )
            {
                register.toInt() => prevNum;
                -1 => MODE;

                register => prevRegister;
                "" => register;
                // <<<"Prev: ", prevNum>>>;
            }
        }

        100::ms => now;
        currInput => lastInput;
    }
}
spork ~ inputMonitor();

fun void displayListener()
{
    while( true )
    {
        display.dispReg(register);
        50::ms => now;
        // buttonReleaseEvent => now;
    }
}
spork ~ displayListener();

// keyboard monitor
fun void KBListener()
{
    while(true){
        if( KB.isKeyDown(KB.KEY_1) )
        {
            if( currSubtitle < numSubtitle )
            {
                subtitles[currSubtitle] --> GG.scene();
                
                if( currSubtitle > 0 )
                {
                    subtitles[currSubtitle - 1] --< GG.scene();
                }

                1 +=> currSubtitle;
            }
        }
        // keyboard even update interval
        100::ms => now;
    }
}
spork ~ KBListener();


// this class is defined only inside calculator.ck
class Display extends GGen
{
    Printing digits[maxReg][10];
    GPlane bg --> this;
    FlatMaterial mtemp;
    bg.mat(mtemp);
    bg.mat().color( displayColor );

    3 * gap + 3.8 => float bgW;
    1 => float bgH;
    
    (3*gap + 4) / 6 => float dGap;

    dGap * 0/8 => float dW => float dH;

    bg.sca( @( bgW, bgH, 0 ) ) ;

    for( int i; i < maxReg; i++ )
    {
        for( int j; j < 10; j++ )
        {
            digits[i][j].init(j, this);


            (-2 + i) * dGap => float xloc; // assume maxReg = 5
            // <<<xloc>>>;
            digits[i][j].pos( @(xloc, 0, -5) );
        }
    }

    fun void resetDigits()
    {
        
        for( int i; i < maxReg; i++ )
        {
            for( int j; j < 10; j++ )
            {
                (-2 + i) * dGap => float xloc; // assume maxReg = 5
                digits[i][j].pos( @(xloc, 0, -5) );
            }
        }
    }

    fun void dispReg(string reg)
    {
        0 => int currDigit;
        resetDigits();
        if( reg.length() > maxReg )
        {
            <<<"Invalid Register Length">>>;
        }
        else
        {
            maxReg - 1 => int counter;
            for( reg.length() => int i; i > 0; i-- )
            {
                reg.substring(i - 1, 1).toInt() => currDigit;
                digits[counter][currDigit].posZ(0);
                1 -=> counter;
            }   
        }
    }
}

// game loop
while (true) 
{ 
    GG.nextFrame() => now; 
}
