[
    59, 60, 62, 64, 65, 67, 69, 71, 72, 74, 76, 79, 84, 86, 0
] @=> global int pitches[];

global string s1, s2;
global int tt; 
// global string s1, s2;

class NewBass{
    float freq;
    SawOsc saw1, saw2;
    SqrOsc sqr1;
    ADSR env;                                      // amplitude EG
    Step step => Envelope filterEnv => blackhole;  // filter cutoff EG
    LPF filter;

    TriOsc freqLFO => blackhole;  // LFO to modulate filter frequency
    TriOsc qLFO => blackhole;     // LFO to modulate filter resonance
    saw1 => env => filter => Gain g => dac;
    // saw2 => env => filter;
    sqr1 => env;

    0.1 => g.gain;
    // initialize amp EG
    env.set(40::ms, 10::ms, .6, 150::ms);

    // initialize filter EG
    step.next(1.0);
    filterEnv.duration(50::ms);

    // initialize filter LFOs
    freqLFO.period(8::second);
    qLFO.period(10::second);

    // initialize filter
    filter.freq(2000);
    filter.Q(2);

    fun void play(int pitch) { // this is an octave lower than the original pitch

        if(pitch < 0)
        {
            0 => g.gain;
        }
        else
        {
            0.1 => g.gain;
            Std.mtof(pitch - 12) => freq;
            // set frequencies
            saw1.freq(freq);
            sqr1.freq(2 * freq * 1.02); // slight detune for more harmonic content

            // activate EGs
            env.keyOn(); filterEnv.keyOn();
            // wait for note to hit sustain portion of ADSR
            env.attackTime() + env.decayTime() => now;
            // deactivate EGs
            env.keyOff(); filterEnv.keyOff();
            // wait for note to finish
            env.releaseTime() => now;
        }
    }
}

public class MusicBox extends Chugraph
{
    // should be an array of score
    int numNote;
    int score1[], score2[];
    NewBass nb1, nb2;
    dur STEP;
    0 => int PLAYING;
    0 => int SCORE_VALID;

    // set score after a register is received
    // fun void setScore(string reg1, string reg2, int type)
    fun void setScore()
    {
        <<<"Reg1: " + s1>>>;
        <<<"Reg2: " + s2>>>;

        s1 => string reg1;
        s2 => string reg2;

        tt => int type;
        
        reg1.length() => numNote;

        int temp1[numNote];
        int temp2[numNote];

        if( reg2.length() == numNote )
        {
            1 => SCORE_VALID;
            for( int i; i < reg1.length(); i++ )
            {
                // <<<reg.substring(i, 1).toInt()>>>;
                pitches[reg1.substring(i, 1).toInt()] => temp1[i];
                pitches[reg2.substring(i, 1).toInt()] + 12 * type => temp2[i];
            }

            temp1 @=> score1;
            temp2 @=> score2;
        }
        else
        {
            0 => SCORE_VALID;
        }
      
    }

    fun void setSpeed(int BPM)
    {
        (1.0/BPM)::minute / 2.0 => STEP;  // step duration
    }

    fun int isPlaying()
    {
        return this.PLAYING;
    }

    fun void startPlay()
    {
        setScore();
        if( SCORE_VALID ){
            1 => this.PLAYING;
            1::second => now;

            <<<s1>>>;
            <<<s2>>>;
            while( PLAYING )
            {
                // <<<"here">>>;
                // <<<score1>>>;
                // <<<score2>>>;
                for( int i; i < numNote; i++ )
                {
                    spork ~ nb1.play(score1[i]);
                    spork ~ nb2.play(score2[i]);
                    STEP => now;
                }
            }
        }

    }

    fun void stopPlay()
    {
        0 => this.PLAYING;
    }
}
